routes/web.php
<?php

use App\Http\Controllers\ProfileController;
use App\Http\Controllers\MessagesController;
use App\Http\Controllers\PagesController;
use App\Http\Controllers\UsersController;
use App\Http\Controllers\RolesController;
use App\Http\Controllers\TagsController;
use App\Http\Controllers\NotesController;

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

// Route::get('/', function () {
//     return view('welcome');
// });

Route::get('test', function() {

    return \App\Models\User::with('mensajes')->get();
});

Route::get('/', 'App\Http\Controllers\MessagesController@create')->name('mensajes.index');

Route::middleware(['auth'])->group(function () {

    Route::resource('usuarios', UsersController::class);
    Route::put('usuarios-cambiaestado/{id}','App\Http\Controllers\UsersController@cambiaEstado')->name('usuarios.estado');   
    
    Route::resource('mensajes', MessagesController::class);
    Route::get('mensajes/pdf', 'App\Http\Controllers\MessagesController@pdf')->name('mensajes.pdf');   
    
    Route::get('mensajes-exportar', 'App\Http\Controllers\MessagesController@export')->name('mensajes.export');
    Route::get('mensajes-importar', 'App\Http\Controllers\MessagesController@import')->name('mensajes.import');
    Route::post('mensajes-importar', 'App\Http\Controllers\MessagesController@import')->name('mensajes.import');
    
    Route::resource('roles', RolesController::class);
    Route::put('roles-cambiaestado/{id}','App\Http\Controllers\RolesController@cambiaEstado')->name('roles.estado');
    
    Route::resource('tags', TagsController::class);
    Route::resource('notas', NotesController::class);
    
    Route::get('componentes', 'App\Http\Controllers\PagesController@componentes')->name('componentes');
    
});


Route::get('documentacion', 'App\Http\Controllers\PagesController@docu')->name('docu');


//AJAX
Route::get('/get-nueva-nota', 'PrtiController@getClasificacionesCGCombo');

//******************************************************************************* */

Auth::routes();

app/Models/Tag.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Tag extends Model
{
    use HasFactory;

    protected $fillable = ['name','descripcion'];

    public function messages() 
    {
       return $this->morphedByMany(Message::class, 'taggable');
    }
}

app/Http/Controllers/TagsController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Tag;

class TagsController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $tags = Tag::all();    

        //return view('mensajes.index', compact('mensajes'));
        return view('tags.index')->with('tags',$tags);
        
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        $tag = new Tag;
        return view('tags.create')->with('tag',$tag);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {               
        $this->validate($request, [
            'name' => 'required|unique:tags,name',
            'descripcion' => 'max:255'           
        ]);       
        
        Tag::create($request->all());
        // $tag->name = $request->name;
        // $tag->descripcion = $request->descripcion;
        // $tag->save();

        return redirect()->back()->with('info','Eiqueta creada con exito');
        
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        $tag = Tag::findorFail($id);

        return view('tags.show')->with('tag',$tag);
        
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(string $id)
    {
        $tag = Tag::findorFail($id);       

        return view('tags.edit')->with('tag',$tag);
        
        
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, string $id)
    {
        $this->validate($request, [
            'name' => 'required|unique:tags,name,'.$id,
            'descripcion' => 'max:255'           
        ]);
        
        $tag = Tag::findorFail($id);
        $tag->update($request->all());
        
        return redirect()->back()->with('info','Etiqueta actualizada');
        
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(string $id)
    {
        $tag = Tag::findorFail($id)->delete();
        
        return redirect()->back()->with('info','Etiqueta eliminada');
    }
}

resources/views/tags/create.blade.php
@extends('adminlte::page')

@section('title', 'Crear Etiqueta')

@section('content_header')
    <h1 class=" col-6 alert alert-info">Nueva Etiqueta</h1>
@stop


@section('content')

    @if (Session()->has('info'))
        <div class="alert alert-success">{{ Session('info')}}</div>
    @endif

    <form action="{{ route('tags.store') }}" method="POST">        
        {!! csrf_field() !!}             
    @include('tags.fields', ['tag' => $tag, 'btnText'=> 'Grabar'])
    </form>

@endsection

resources/views/tags/edit.blade.php
@extends('adminlte::page')

@section('title', 'Editar etiqueta')

@section('content_header')
    <h1 class="text-center alert alert-info">Módulo de etiquetas 😎✉</h1>
@stop


@section('content')    

    @if (Session()->has('info'))
    <div class="alert alert-success">{{ Session('info')}}</div>
    @endif

    <form action="{{route('tags.update',$tag->id)}}" method="post">
        {!!method_field('PUT')!!}
        {!! csrf_field() !!}    
        @include('tags.fields', ['tag' => $tag, 'btnText' => 'Actualizar'])
    </form>

@endsection

resources/views/tags/fields.blade.php
<div class="form-group col-6">
    <label class="form-label" for="name">Nombre </label>
    <input class="form-control" type="text" name="name" id="name" value="{{ $tag->name ?? old('name') }}"/>
    @if ($errors->first('name'))
        <span class="alert alert-danger btn btn-sm">{{ $errors->first('name') }}</span> 
    @endif                              
</div>

<div class="form-group col-6">
    <label class="form-label" for="descripcion"> Descripcion </label>
    <input class="form-control" autocomplete="true" type="descripcion" name="descripcion" id="descripcion" value="{{ $tag->descripcion ?? old('descripcion') }}"/>
    @if ($errors->first('descripcion'))
        <span class="alert alert-danger btn btn-sm"> {{ $errors->first('descripcion') }}</span>
    @endif
</div> 

<div class="col-6">
    <button type="submit" class="btn btn-success btn-md">{{ $btnText }}</button>
</div>

resources/views/tags/index.blade.php
@extends('adminlte::page')

@section('title', 'Etiquetas')

@section('content_header')
    <h1 class="text-center alert alert-info">Modulo de Etiquetas</h1>
@stop

@section('content')

@if (Session()->has('info'))
    <div class="alert alert-success"> {{Session('info')}}</div>
@endif

<table class="table table-striped table-hover text-center">    
    <thead>
        <tr class="table-info">
            <th>ID</th>
            <th>Nombre</th>            <
            <th>Descripcion</th>
            <th>Acciones</th>
                       
        </tr>
    </thead>

    <tbody>       

        @foreach ($tags as $t)
            <tr>
                <td>{{ $t->id }}</td>
                <td>{{ $t->name }}</td>                
                <td>{{ $t->descripcion }}</td>                
                <td>
                    <a class="btn btn-info btn-sm" href="{{ route('tags.show',$t->id)}}">Ver</a>
                    <a class="btn btn-warning btn-sm" href="{{ route('tags.edit',$t->id)}}">Editar</a>
                    <form action="{{ route('tags.destroy',$t->id)}}" method="post" class="d-inline">
                        {!!method_field('DELETE')!!}
                        {!! csrf_field() !!}
                        <button class="btn btn-danger btn-sm" type="submit">Eliminar</button>
                    </form>                 
                   
                </td>           
               
            </tr>
                    
        @endforeach
    
    </tbody>
</table>

@endsection

resources/views/tags/show.blade.php
@extends('adminlte::page')

@section('title', 'Ver Eriqueta')

@section('content')

<div class="card">
    <div class="card-title text-left alert alert-info">
         Ver Etiqueta 🏷
    </div>
       
    <div class="card-body">
       
        <div class="row">

            <div class="col-xs-12 col-sm-12 col-md-12">

                <table class="table table-striped table-hover table-bordered">
                    <tbody>
                        <tr> 
                            <td><strong>Nombre</strong></td>
                            <td> {{ $tag->name }}</td>
                        </tr>                        

                        <tr> 
                            <td><strong>Descripcion</strong></td>
                            <td> {{ $tag->descripcion }}</td>
                        </tr>                                          

                    </tbody>
                </table>
               

            </div>

        </div>

    </div>
</div>

@endsection